function vexpower.panel_energybar()
	return {
		type = "group",
		order= 3,
		args = {
			grppos = {
				name = "Position and Size",
				order=1, type ="group", dialogInline = true,
				args = {
					framewidth = {
						name = "Width",
						order=1, type = "range",
						desc = "Sets the width of the frame",
						step = 1, min = 0, max = 2000,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["size"]["width"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["size"]["width"] end
						},
					frameheight = {
						name = "Height",
						order=2, type = "range",
						desc = "Sets the height of the frame",
						step = 1, min = 0, max = 2000,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["size"]["height"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["size"]["height"] end
						},
					frame_size_space = {name =" ", type = "description", order=3},
					frameposx = {
						name = "X Position",
						order=4, type = "range",
						desc = "Sets the x position of the frame",
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["position"]["x"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["position"]["x"] end
						},
					frameposy = {
						name = "Y Position",
						order=5, type = "range",
						desc = "Sets the y position of the frame",
						step = 1, min = -2000, max = 2000,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["position"]["y"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["position"]["y"] end
						},
					frameanchor = {
						name = "Anchor",
						order=6, type = "select", style = "dropdown",
						desc = "Sets the achor of the frame",
						values = {
							["CENTER"]="Center",
							["BOTTOM"]="Bottom",
							["TOP"]="Top",
							["LEFT"]="Left",
							["RIGHT"]="Right",
							["BOTTOMLEFT"]="Bottomleft",
							["BOTTOMRIGHT"]="Bottomright",
							["TOPLEFT"]="Topleft",
							["TOPRIGHT"]="Topright"},
						set = function(self,key) vexpower_parameters["frame"]["energy"]["position"]["anchor"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["position"]["anchor"] end,
						},
					},
				},
			frame_space1 = {name ="\n", type = "description", order=2},
				
			grppowerpool = {
				name = "Power Pool",
				order=3, type ="group", dialogInline = true,
				args = {
					frametypecolored = {
						name = "Use blizzard's colors for mana/energy/etc (opacity can still be changed)",
						order=1, type = "toggle", width="full",
						desc = "",
						set = function(self,key) vexpower_parameters["frame"]["energy"]["typecolored"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["typecolored"] end,
						},
					frameenergycolor = {
						name = "Alternative color", width="double",
						order=2, type = "color", hasAlpha=false,
						desc = "background color used when not using blizzard's preset colors",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["color"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["color"]["b"] end,
						},
					opacityframe = {
						name = "Opacity %",
						order=3, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["color"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["color"]["a"]*100 end
						},
					frameenergyusedcolor = {
						name = "Color for 'used'-energy", width="double",
						order=5, type = "color", hasAlpha=false,
						desc = "Color of the energy that has just been used",
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["usedcolor"]["r"]=r
							vexpower_parameters["frame"]["energy"]["usedcolor"]["g"]=g
							vexpower_parameters["frame"]["energy"]["usedcolor"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["usedcolor"]["r"],
							vexpower_parameters["frame"]["energy"]["usedcolor"]["g"],
							vexpower_parameters["frame"]["energy"]["usedcolor"]["b"] end,
						},
					opacityused = {
						name = "Opacity %",
						order=6, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["usedcolor"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["usedcolor"]["a"]*100 end
						},
					framebackdrop = {
						name = "Texture",
						order=7, type = "select",
						dialogControl = "LSM30_Background",
						desc = "Sets the frame's background-texture",
						values = vexpower.LSM:HashTable("background"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["bg"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["bg"] end,
						},
					},
				},
			frame_space2 = {name ="\n", type = "description", order=4},
					
			grpbackground = {
				name = "Background",
				order=5, type ="group", dialogInline = true,
				args = {
					framebackdropbg = {
						name = "Background Texture",
						order=1, type = "select",
						dialogControl = "LSM30_Background",
						values = vexpower.LSM:HashTable("background"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["bg_texture"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["bg_texture"] end,
						},
					frameenergybgcolor = {
						name = "Background Color",
						order=2, type = "color", hasAlpha=false,
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["bgcolor"]["r"]=r
							vexpower_parameters["frame"]["energy"]["bgcolor"]["g"]=g
							vexpower_parameters["frame"]["energy"]["bgcolor"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["bgcolor"]["r"],
							vexpower_parameters["frame"]["energy"]["bgcolor"]["g"],
							vexpower_parameters["frame"]["energy"]["bgcolor"]["b"] end,
						},
					opacitybg = {
						name = "Background Opacity %",
						order=3, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["bgcolor"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["bgcolor"]["a"]*100 end
						},
					framebgspace = {name ="\n", type = "description", order=4},
					framebackdrop = {
						name = "Border Texture",
						order=5, type = "select",
						dialogControl = "LSM30_Border",
						values = vexpower.LSM:HashTable("border"),
						set = function(self,key) vexpower_parameters["frame"]["energy"]["border"]["texture"]=key vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["border"]["texture"] end,
						},
					frameenergybordercolor = {
						name = "Border Color",
						order=6, type = "color", hasAlpha=false,
						set = function(info,r,g,b,a)
							vexpower_parameters["frame"]["energy"]["border"]["color"]["r"]=r
							vexpower_parameters["frame"]["energy"]["border"]["color"]["g"]=g
							vexpower_parameters["frame"]["energy"]["border"]["color"]["b"]=b
							vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["border"]["color"]["r"],
							vexpower_parameters["frame"]["energy"]["border"]["color"]["g"],
							vexpower_parameters["frame"]["energy"]["border"]["color"]["b"] end,
						},
					opacityborder = {
						name = "Border Opacity %",
						order=7, type = "range",
						desc = "Sets the opacity",
						step = 5, min = 0, max = 100,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["border"]["color"]["a"]=val/100 vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["border"]["color"]["a"]*100 end
						},
					frameenergybordersize = {
						name = "Border Size",
						order=8, type = "range",
						step = 1, min = 1, max = 15,
						set = function(info,val) vexpower_parameters["frame"]["energy"]["border"]["size"]=val vexpower_initialize(true) end,
						get = function() return vexpower_parameters["frame"]["energy"]["border"]["size"] end
						},
					},
				},
			}
		}
end